#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Note:
#  gold = model/kyoto/{train,dev,test}.JDP.utf8
#  auto = cat model/kyoto/{train,dev.test}.JDP.utf8 | \
#         ruby -e 'while line = gets do \
#           next if line =~/^#/; \
#           if line =~/^E/ then \
#             print "\n"
#           elsif line !~ /^\*/ then \
#             print line.split(/\t/)[0]
#           end; \
#         end' | \
#         knp -dpnd -tab | python tools/knp2kyoto.py > {train,dev,test}.knp
import sys, re

if len (sys.argv) < 3:
    sys.exit ("Usage: %s gold auto" % sys.argv[0])

def collect_info (fn):
    sep = re.compile (r'(?:\t|\s)*')
    chunk, depnd = [], []
    l, pos, head, head_type = 0, [], [], []
    for line in open (fn):
        if   line[0] == '#':
            pass
        elif line[0] == '*':
            if line[-3] != '-':
                head.append (int (line[:-1].split (' ')[2][:-1]))
                head_type.append (line[:-1].split (' ')[2][-1])
            pos.append (l)
        elif line[0] == 'E':
            pos.append (l)
            chunk_pos = []
            for i in range (1, len (pos)):
                chunk_pos.append (tuple ([pos[i-1], pos[i]]))
            chunk.append (chunk_pos)
            depnd.append ([])
            for i in range (0, len (chunk_pos) - 1):
                depnd[-1].append (tuple ([chunk_pos[i], chunk_pos[head[i]], head_type[i]]))
            l, pos, head, head_type = 0, [], [], []
        else:
            l += len (sep.split (line[:-1], 1)[0])
    return chunk, depnd

chunk_g, depnd_g = collect_info (sys.argv[1])
chunk_a, depnd_a = collect_info (sys.argv[2])

if len (chunk_a) != len (chunk_g):
    sys.stderr.write ("# sentences mismatched\n")

i = 0
j = 0
ok = 0
all = 0
for line in open (sys.argv[1]):
    if line[0] == '*':
        if j < len (depnd_g[i]):
            all += 1
            pos = chunk_g[i][j]
            hid = -1
            htype = 'D'
            if pos in chunk_a[i]:
                id_ = chunk_a[i].index (pos)
                hpos, htype = depnd_a[i][id_][1:]
                if hpos in chunk_g[i]:
                    ok += 1
                    hid = chunk_g[i].index (hpos)
        sys.stdout.write ("%s %d%s\n" % (line[:-1], hid, htype))
        j += 1
    else:
        sys.stdout.write (line)
        if line[0] == 'E':
            i += 1
            j = 0
sys.stderr.write ("%d\n" % ok)
sys.stderr.write ("%d\n" % all)
